
#ifdef HAVE_CONFIG_H
#include "conf.h"
#endif


#if defined(FX)

#include "types.h"
#include "cva.h"
#include "mmath.h"
#include "fxdrv.h"
#include "X86/common_x86asm.h"


#if 0 && defined(__i386__)
#define NEGATIVE(f)          ((*(int *)&f) < 0)
#define DIFFERENT_SIGNS(a,b) (((*(int *)&a)^(*(int *)&b)) < 0)
#else
#define NEGATIVE(f)          (f < 0)
#define DIFFERENT_SIGNS(a,b) ((a*b) < 0)
#endif

#define LINTERP( T, A, B )   ( (A) + (T) * ( (B) - (A) ) )


#define CLIP(sgn,v,PLANE)					\
if (mask & PLANE) {						\
   GLuint *indata = inlist[in];					\
   GLuint *outdata = inlist[in ^= 1];				\
   GLuint nr = n;						\
   GLfloat *J = verts[indata[nr-1]].f;				\
   GLfloat dpJ = (sgn J[v]) + J[3];				\
								\
   inlist[0] = vlist1;						\
   for (i = n = 0 ; i < nr ; i++) {				\
      GLuint elt_i = indata[i];					\
      GLfloat *I = verts[elt_i].f;				\
      GLfloat dpI = (sgn I[v]) + I[3];				\
								\
      if (DIFFERENT_SIGNS(dpI, dpJ)) {				\
	 GLfloat *O = verts[next_vert].f;			\
         GLfloat t = dpI / (dpI - dpJ);				\
	 GLuint j;						\
								\
	 clipmask[next_vert] = 0;				\
	 outdata[n++] = next_vert++;				\
								\
         for (j = 0 ; j < SIZE ; j += 2) {			\
	    O[j]   = LINTERP(t, I[j],   J[j]);			\
	    O[j+1] = LINTERP(t, I[j+1], J[j+1]);	       	\
	 }							\
      }								\
								\
      clipmask[elt_i] |= PLANE;		/* don't set up */	\
								\
      if (!NEGATIVE(dpI)) {					\
	 outdata[n++] = elt_i;					\
	 clipmask[elt_i] &= ~PLANE;	/* set up after all */	\
      }								\
								\
      J = I;							\
      dpJ = dpI;						\
   }								\
								\
   if (n < 3) return;						\
}

#define LINE_CLIP(x,y,z,w,PLANE)				\
if (mask & PLANE) {						\
   GLfloat dpI = DOT4V(I,x,y,z,w);				\
   GLfloat dpJ = DOT4V(J,x,y,z,w);				\
								\
   if (DIFFERENT_SIGNS(dpI, dpJ)) {				\
      GLfloat *O = verts[next_vert].f;				\
      GLfloat t = dpI / (dpI - dpJ);				\
      GLuint j;							\
								\
      for (j = 0 ; j < SIZE ; j += 2) {				\
         O[j]   = LINTERP(t, I[j],   J[j]);			\
	 O[j+1] = LINTERP(t, I[j+1], J[j+1]);	       		\
      }								\
								\
      clipmask[next_vert] = 0;					\
								\
      if (NEGATIVE(dpI)) {					\
  	 clipmask[elts[0]] |= PLANE;				\
	 I = O; elts[0] = next_vert++;				\
      } else {							\
  	 clipmask[elts[1]] |= PLANE;				\
	 J = O;	elts[1] = next_vert++;				\
      }								\
   }								\
   else if (NEGATIVE(dpI))					\
      return;							\
}


#define CLIP_POINT( e )				\
   if (mask[e])					\
      *out++ = e 

#define CLIP_LINE( e1, e0 )						\
do {									\
   GLubyte ormask = mask[e0] | mask[e1];				\
   out[0] = e1;								\
   out[1] = e0;								\
   out+=2;								\
   if (ormask) {							\
      out-=2;								\
      if (!(mask[e0] & mask[e1])) {					\
	 TAG(fx_line_clip)( &out, verts, mask, &next_vert, ormask);	\
      }									\
   }									\
} while (0)

#define CLIP_TRIANGLE( e2, e1, e0 )					\
do {									\
   GLubyte ormask;							\
   out[0] = e2;								\
   out[1] = e1;								\
   out[2] = e0;								\
   out += 3;								\
   ormask = mask[e2] | mask[e1] | mask[e0];				\
   if (ormask) {							\
      out -= 3;								\
      if ( !(mask[e2] & mask[e1] & mask[e0])) {				\
	 TAG(fx_tri_clip)( &out, verts, mask, &next_vert, ormask );	\
      }									\
   }									\
} while (0)



#if defined(FX_V2)

#define VARS_XYZ				\
  GLfloat vsx = mat[MAT_SX];			\
  GLfloat vsy = mat[MAT_SY];			\
  GLfloat vsz = mat[MAT_SZ];			\
  GLfloat vtx = mat[MAT_TX];			\
  GLfloat vty = mat[MAT_TY];			\
  GLfloat vtz = mat[MAT_TZ];

#define DO_SETUP_XYZ				\
  f[XCOORD] = f[0] * oow * vsx + vtx;		\
  f[YCOORD] = f[1] * oow * vsy + vty;		\
  f[ZCOORD] = f[2] * oow * vsz + vtz;

#else
#if defined(HAVE_FAST_MATH)

#define VARS_XYZ				\
  GLfloat vsx = mat[MAT_SX];			\
  GLfloat vsy = mat[MAT_SY];			\
  GLfloat vsz = mat[MAT_SZ];			\
  const GLfloat snapper = (3L << 18);		\
  GLfloat vtx = mat[MAT_TX] + snapper;		\
  GLfloat vty = mat[MAT_TY] + snapper;		\
  GLfloat vtz = mat[MAT_TZ];

#define DO_SETUP_XYZ				\
  f[XCOORD] = f[0] * oow * vsx + vtx;		\
  f[XCOORD] -= snapper;				\
  f[YCOORD] = f[1] * oow * vsy + vty;		\
  f[YCOORD] -= snapper;				\
  f[ZCOORD] = f[2] * oow * vsz + vtz;

#else

#define VARS_XYZ				\
  GLfloat vsx = mat[MAT_SX] * 16.0;		\
  GLfloat vsy = mat[MAT_SY] * 16.0;		\
  GLfloat vsz = mat[MAT_SZ];			\
  GLfloat vtx = mat[MAT_TX] * 16.0;		\
  GLfloat vty = mat[MAT_TY] * 16.0;		\
  GLfloat vtz = mat[MAT_TZ];

#define DO_SETUP_XYZ					\
  f[XCOORD] = ((int)(f[0]*oow*vsx+vtx)) * (1.0/16.0);	\
  f[YCOORD] = ((int)(f[1]*oow*vsy+vty)) * (1.0/16.0);	\
  f[ZCOORD] = f[2]*oow*vsz + vtz;


#endif
#endif


static GLenum fx_reduce_prim[GL_POLYGON+1] = {
   GL_POINTS,
   GL_LINES,
   GL_LINES,
   GL_LINES,
   GL_TRIANGLES,
   GL_TRIANGLES,
   GL_TRIANGLES,
   GL_TRIANGLES,
   GL_TRIANGLES,
   GL_TRIANGLES,
};  



void fxtransform( struct vertex_buffer *VB,
		  const GLfloat * m, 
		  GLuint start, 
		  GLuint count)
{
   GLfloat *obj = VEC_ELT(VB->ObjPtr, GLfloat, start);
   GLuint obj_stride = VB->ObjPtr->stride;
   GLfloat *f = FX_DRIVER_DATA(VB)->verts[start].f;
   GLuint i;

   for (i = start ; i < count ; i++, STRIDE_F(obj, obj_stride), f+=16) 
   {
      const GLfloat ox = obj[0], oy = obj[1], oz = obj[2];
      f[0] = m[0] * ox + m[4] * oy + m[8]  * oz + m[12];
      f[1] = m[1] * ox + m[5] * oy + m[9]  * oz + m[13];
      f[2] = m[2] * ox + m[6] * oy + m[10] * oz + m[14];
      f[3] = m[3] * ox + m[7] * oy + m[11] * oz + m[15];
   }
}


void fxcliptest( GLfloat *f,
		 GLfloat *last,
		 GLubyte *p_clipOr,
		 GLubyte *p_clipAnd,
		 GLubyte *clipmask )
{	
   GLubyte clipAnd = ~0;
   GLubyte clipOr = 0;

   for ( ; f != last ; f+=16, clipmask++) 
   {
      const GLfloat cx = f[0];
      const GLfloat cy = f[1];
      const GLfloat cz = f[2];
      const GLfloat cw = f[3];      
      GLubyte mask = 0;

      if (cx >  cw) mask |= CLIP_RIGHT_BIT;
      if (cx < -cw) mask |= CLIP_LEFT_BIT;
      if (cy >  cw) mask |= CLIP_TOP_BIT;
      if (cy < -cw) mask |= CLIP_BOTTOM_BIT;
      if (cz >  cw) mask |= CLIP_FAR_BIT;
      if (cz < -cw) mask |= CLIP_NEAR_BIT;

      *clipmask = mask;
      clipAnd &= mask;
      clipOr |= mask;
   }

   (*p_clipOr) |= clipOr;
   (*p_clipAnd) &= clipAnd;
}



#if defined(USE_X86_ASM) && defined(__GNUC__)

#if defined(USE_3DNOW_ASM)
/* KW: A single loop seems to be faster than two loops for large
 * stride output vertices.  My guess is that cache misses are the
 * culprit, but it might just be my coding. 
 */
static void gl_3dnow_transform_points3_general_raw_fx2 (
   struct vertex_buffer *VB,
   const GLfloat *m,
   GLuint start,
   GLuint count )
{
   int stride = VB->ObjPtr->stride;
   float *from = VEC_ELT(VB->ObjPtr, GLfloat, start);
   GLfloat *dest = FX_DRIVER_DATA(VB)->verts[start].f;
   int c = count;

   int d0, d1, d2, d3, d4;

__asm__ __volatile__ (

"		femms   \n"
"  		test		%3,%3   \n"
"		jle		3f   \n"
"   \n"
"		movq		48(%1),%%mm7  # m31         | m30     \n"
"		movq		56(%1),%%mm3  # m33         | m32   \n"
"   \n"
".balign	32   \n"
"2:   \n"
"               prefetchw       128(%0)       # prefetch 2 output verts ahead\n"
"		movq		(%2),  %%mm0  # x1          | x0   \n"
"		movd		8(%2), %%mm1  #             | x2   \n"
"		movq		(%1),  %%mm4  # m00         | m01   \n"
"		punpckhdq	%%mm0, %%mm2  # x1          |       \n"
"		movq		16(%1),%%mm5  # m10         | m11   \n"
"		punpckldq	%%mm0, %%mm0  # x0          | x0   \n"
"		movq		32(%1),%%mm6  # m20         | m21   \n"
" 		pfmul		%%mm0, %%mm4  # x0.m01      | x0.m00   \n"
"		punpckhdq	%%mm2, %%mm2  # x1          | x1   \n"
"		pfmul		%%mm2, %%mm5  # x1.m11      | x1.m10   \n"
"		punpckldq	%%mm1, %%mm1  # x2          | x2   \n"
"		pfmul		8(%1), %%mm0  # x0.m03      | x0.m02   \n"
"		pfmul		24(%1),%%mm2  # x1.m13      | x1.m12   \n"
"		pfmul		%%mm1, %%mm6  # x2.m21      | x2.m20   \n"
"		pfadd		%%mm4, %%mm5  # x0m01+x1m11 | x0m00+x1m10   \n"
"		pfmul		40(%1),%%mm1  # x2.m21      | x2.m20   \n"
"		pfadd		%%mm0, %%mm2  # x0m03+x1m13 | x0m02+x1m12   \n"
"		pfadd		%%mm5, %%mm6  # (xm012)1    | (xm012)0   \n"
"		pfadd		%%mm1, %%mm2  # (xm012)3    | (xm012)2   \n"
"		pfadd		%%mm7, %%mm6  # r1          | r0   \n"
"		pfadd		%%mm3, %%mm2  # r3          | r2   \n"
"		add		%4,    %2     # next input     \n"
"		movq		%%mm6, (%0)   #    \n"
"		movq		%%mm2, 8(%0)  #   \n"
"		add		$64,   %0     # next output   \n"
"		dec		%3   \n"
"		jne		2b   \n"
"   \n"
"3:   \n"
"		femms   \n"

/* eax: dest
 * esi: mat (was ebx)
 * edx: from
 * ecx: count
 * edi: input stride
 */

	 : "=&a"(d0), "=&S"(d1), "=&d"(d2), "=&c"(d3), "=&D"(d4)
	 : "0" (dest), "1" (m), "2" (from), "3" (c), "4" (stride) 
	 : "memory"); 
}

#endif


/* This is nothing more glamorous than an objdump of one of Josh's
 * routines hacked to match the above.    
 */
static void gl_x86_transform_points3_general_raw_fx2 (
   struct vertex_buffer *VB,
   const GLfloat *m,
   GLuint start,
   GLuint count )
{
   int stride = VB->ObjPtr->stride;
   float *from = VEC_ELT(VB->ObjPtr, GLfloat, start);
   GLfloat *dest = FX_DRIVER_DATA(VB)->verts[start].f;

   int d0, d1, d2, d3, d4;

__asm__ __volatile__ (

"             testl  %3, %3    \n"
"             je     3f    \n"
".balign 16    \n"
"2:    \n"
"             flds   0x0(%2)    \n"
"             fmuls  0x0(%1)    \n"
"             flds   0x0(%2)    \n"
"             fmuls  0x4(%1)    \n"
"             flds   0x0(%2)    \n"
"             fmuls  0x8(%1)    \n"
"             flds   0x0(%2)    \n"
"             fmuls  0xc(%1)    \n"
"             flds   0x4(%2)    \n"
"             fmuls  0x10(%1)    \n"
"             flds   0x4(%2)    \n"
"             fmuls  0x14(%1)    \n"
"             flds   0x4(%2)    \n"
"             fmuls  0x18(%1)    \n"
"             flds   0x4(%2)    \n"
"             fmuls  0x1c(%1)    \n"
"             fxch   %%st(3)    \n"
"             faddp  %%st,%%st(7)    \n"
"             fxch   %%st(1)    \n"
"             faddp  %%st,%%st(5)    \n"
"             faddp  %%st,%%st(3)    \n"
"             faddp  %%st,%%st(1)    \n"
"             flds   0x8(%2)    \n"
"             fmuls  0x20(%1)    \n"
"             flds   0x8(%2)    \n"
"             fmuls  0x24(%1)    \n"
"             flds   0x8(%2)    \n"
"             fmuls  0x28(%1)    \n"
"             flds   0x8(%2)    \n"
"             fmuls  0x2c(%1)    \n"
"             fxch   %%st(3)    \n"
"             faddp  %%st,%%st(7)    \n"
"             fxch   %%st(1)    \n"
"             faddp  %%st,%%st(5)    \n"
"             faddp  %%st,%%st(3)    \n"
"             faddp  %%st,%%st(1)    \n"
"             fxch   %%st(3)    \n"
"             fadds  0x30(%1)    \n"
"             fxch   %%st(2)    \n"
"             fadds  0x34(%1)    \n"
"             fxch   %%st(1)    \n"
"             fadds  0x38(%1)    \n"
"             fxch   %%st(3)    \n"
"             fadds  0x3c(%1)    \n"
"             fxch   %%st(2)    \n"
"             fstps  0x0(%0)    \n"
"             fstps  0x4(%0)    \n"
"             fxch   %%st(1)    \n"
"             fstps  0x8(%0)    \n"
"             fstps  0xc(%0)    \n"
"             addl   $64,%0    \n"
"             addl   %4,%2    \n"
"             decl   %3       \n"
"             jne    2b    \n"
"3:    \n"

/* eax: dest
 * esi: mat (was ebx, egcs barfed)
 * edx: from
 * ecx: count
 * edi: input stride
 */

	 : "=&a"(d0), "=&S"(d1), "=&d"(d2), "=&c"(d3), "=&D"(d4)
	 : "0" (dest), "1" (m), "2" (from), "3" (count), "4" (stride) 
	 : "memory"); 
}

#endif

/* Pointers to hook in my experimental asm.  These are just a hack &
 * will probably disappear in preference to some other mechanism before
 * long.  
 */
typedef void (*fx_transform_func)( struct vertex_buffer *VB,
				   const GLfloat *m,
				   GLuint start,
				   GLuint count );

typedef void (*fx_cliptest_func)( GLfloat *first_vert,
				  GLfloat *last_vert,
				  GLubyte *or_mask,
				  GLubyte *and_mask,
				  GLubyte *clip_mask );

static fx_transform_func transform_ptr;
static fx_cliptest_func cliptest_ptr;			      

/* Perhaps this is the mechanism I talk about above:
 */
struct fx_fast_tab {
   void (*build_vertices)( struct vertex_buffer *VB );

   void (*clip[GL_POLYGON+1])( struct vertex_buffer *VB, 
			       GLuint start,
			       GLuint count,
			       GLuint parity );

   void (*project_clipped_vertices)( struct vertex_buffer *VB );
   void (*project_vertices)( struct vertex_buffer *VB );
};

/* Pack either rgba or texture into the remaining half of a 32 byte vertex.
 */
#define CLIP_R  CLIP_RCOORD
#define CLIP_G  CLIP_GCOORD
#define CLIP_B  CLIP_BCOORD
#define CLIP_A  CLIP_ACOORD
#define CLIP_S0 4		
#define CLIP_T0 5
#define CLIP_S1 6
#define CLIP_T1 7

#define SIZE 4
#define TYPE (0)
#define TAG(x) x
#include "fxfasttmp.h"

#define SIZE 8
#define TYPE (SETUP_RGBA)
#define TAG(x) x##_RGBA
#include "fxfasttmp.h"

#define SIZE 6
#define TYPE (SETUP_TMU0)
#define TAG(x) x##_TMU0
#include "fxfasttmp.h"

#define SIZE 8
#define TYPE (SETUP_TMU0|SETUP_TMU1)
#define TAG(x) x##_TMU0_TMU1
#include "fxfasttmp.h"

#undef CLIP_S1
#undef CLIP_T1
#define CLIP_S1 4
#define CLIP_T1 5

#define SIZE 6
#define TYPE (SETUP_TMU1)
#define TAG(x) x##_TMU1
#include "fxfasttmp.h"

/* These three need to use a full 64 byte clip-space vertex.
 */
#undef CLIP_S0
#undef CLIP_T0
#undef CLIP_S1
#undef CLIP_T1

#define CLIP_S0 8
#define CLIP_T0 9
#define CLIP_S1 10
#define CLIP_T1 11

#define SIZE 10
#define TYPE (SETUP_RGBA|SETUP_TMU0)
#define TAG(x) x##_RGBA_TMU0
#include "fxfasttmp.h"

#define SIZE 12
#define TYPE (SETUP_RGBA|SETUP_TMU0|SETUP_TMU1)
#define TAG(x) x##_RGBA_TMU0_TMU1
#include "fxfasttmp.h"

#undef CLIP_S1
#undef CLIP_T1
#define CLIP_S1 8
#define CLIP_T1 9

#define SIZE 10
#define TYPE (SETUP_RGBA|SETUP_TMU1)
#define TAG(x) x##_RGBA_TMU1
#include "fxfasttmp.h"

static struct fx_fast_tab fxFastTab[0x8];

void fxDDFastPathInit()
{
   cliptest_ptr = fxcliptest;
   transform_ptr = fxtransform;

#if defined(USE_X86_ASM) && defined(__GNUC__)
   /* Just a quick & dirty hack to try some asm out. */
   if (getenv("MESA_NO_ASM") == 0)
   { 
      extern void gl_x86_FX_cliptest_points4(GLfloat *first_vert,
					     GLfloat *last_vert,
					     GLubyte *or_mask,
					     GLubyte *and_mask,
					     GLubyte *clip_mask );

      
      cliptest_ptr = gl_x86_FX_cliptest_points4;
      transform_ptr = gl_x86_transform_points3_general_raw_fx2;
#if 0
/*#ifdef USE_3DNOW_ASM      */
      if (gl_x86_cpu_features & GL_CPU_3Dnow) {
	 fprintf(stderr, "using 3dnow code in fx fast path\n");
	 transform_ptr = gl_3dnow_transform_points3_general_raw_fx2;
      }
      else 
	 fprintf(stderr, "using plain x86 code in fx fast path\n");

#endif
   }
#endif

   /* These check cpu_features.
    */
   fx_init_fastpath( &fxFastTab[0] );
   fx_init_fastpath_RGBA( &fxFastTab[SETUP_RGBA] );
   fx_init_fastpath_TMU0( &fxFastTab[SETUP_TMU0] );
   fx_init_fastpath_TMU1( &fxFastTab[SETUP_TMU1] );
   fx_init_fastpath_RGBA_TMU0( &fxFastTab[SETUP_RGBA|SETUP_TMU0] );
   fx_init_fastpath_RGBA_TMU1( &fxFastTab[SETUP_RGBA|SETUP_TMU1] );
   fx_init_fastpath_TMU0_TMU1( &fxFastTab[SETUP_TMU0|SETUP_TMU1] );
   fx_init_fastpath_RGBA_TMU0_TMU1( &fxFastTab[SETUP_RGBA|SETUP_TMU0|
					       SETUP_TMU1] );
}







void fxDDFastPath( struct vertex_buffer *VB )
{
   GLcontext *ctx = VB->ctx;
   GLenum prim = ctx->CVA.elt_mode;
   struct tfxMesaContext *fxMesa = FX_CONTEXT(ctx);
   struct fx_fast_tab *tab = &fxFastTab[fxMesa->setupindex & 0x7];

   if (fxMesa->new_state) 
      fxSetupFXUnits( ctx );

   gl_prepare_arrays_cva( VB );	                /* still need this */
   tab->build_vertices( VB );	                /* object->clip space */

   if (VB->ClipOrMask) {
      if (!VB->ClipAndMask) {
	 GLuint count = VB->EltPtr->count;
	 GLubyte tmp = VB->ClipOrMask;

	 /* Reserve enough space for the pathological case.
	  */
	 if (count * 12 > FX_DRIVER_DATA(VB)->size)
	    fxDDResizeVB( FX_DRIVER_DATA(VB), count * 12 );

	 tab->clip[prim]( VB, 0, count, 0 );    /* clip to new elt list */
	 tab->project_clipped_vertices( VB );   /* clip->device space */

	 ctx->CVA.elt_mode = fx_reduce_prim[prim];
	 VB->EltPtr = &(FX_DRIVER_DATA(VB)->clipped_elements);

	 VB->ClipOrMask = 0;
	 fxDDRenderElementsDirect( VB );        /* render using new list */
	 VB->ClipOrMask = tmp;
      }
   } else {
      tab->project_vertices( VB );              /* clip->device space  */
      fxDDRenderElementsDirect( VB );           /* render using orig list */
   }

   /* This indicates that there is no cached data to reuse.  
    */
   VB->pipeline->data_valid = 0;
}


#else

/*
 * Need this to provide at least one external definition.
 */
int gl_fxfastpath_dummy(void)
{
  return 0;
}

#endif
